// I don't remember what the purpose of this program is, but it reads
// QWK index files and finds out which block is for which message area
// (20 message areas)

#include <stdio.h>
#include <string.h>

#define maxfiles 21
#define maxblock 500

unsigned long convert (int m1, int m2, int m3, int exp)
{
     return (((m1 + ((unsigned long) m2 << 8) + ((unsigned long) m3 << 16)) | 0x800000L) >> (24 - (exp - 0x80)));
}

char files [maxfiles] [13];


void main ()
{
	unsigned long result;
	int confno [maxblock];
	int num[4];
	int count, which;
	FILE *fp;
	int ok;
	unsigned long highest;

	which = 0;
	count = 0;
	highest = 0;

	for (which = 0; which < maxblock; which ++)
		confno[which] = -1;
	for (which = 0; which < maxfiles; which ++)
		sprintf(files[which],"%03i.ndx",which);

	for (which = 0; which < maxfiles; which ++)
	{
		ok = 1;
		count = 0;
		printf ("Reading %s\n",files[which]);
		fp = fopen (files[which],"rb");
		if (fp != NULL) do
		{
			num[count] = fgetc (fp);

			if (num[count] == EOF)
				ok = 0;
			else
				count ++;
			if (count == 4)
			{
				fgetc(fp);    /* Read and discard every fifth number */
				result = convert (num[0],num[1],num[2],num[3]);
				printf ("result = %lu.",result);
				confno[result] = which;
				if (result > highest)
					highest = result;
				count = 0;
			}
		} while (ok);
		fclose (fp);
	}
	for (which = 0; which <= highest; which ++)
		if (confno[which] >= 0)
			printf ("block %i is in conf %i\n",which, confno[which]);
}

